﻿using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using WPFDockingManager.McsControls;

namespace WPFDockingManager
{
    public partial class MainWindow : Window
    {
        private UserControl_AppLog AppLog;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void MenuItemExit_Click(object sender, RoutedEventArgs e)
        {
            this.OnClosed(e);
        }

        private void MenuItemClear_Click(object sender, RoutedEventArgs e)
        {
            this.SyncDockingManager.Children.Clear();
        }

        private void MenuItemAppLog_Click(object sender, RoutedEventArgs e)
        {
            if (AppLog == null)
            {
                AppLog = new UserControl_AppLog();
                DockingManager.SetHeader(AppLog, "AppLog");
                DockingManager.SetState(AppLog, DockState.Dock);
                DockingManager.SetSideInDockedMode(AppLog, DockSide.Bottom);
                DockingManager.SetDockAbility(AppLog, DockAbility.None);
                DockingManager.SetCanFloat(AppLog, false);
                DockingManager.SetCanAutoHide(AppLog, true);
                DockingManager.SetCanDocument(AppLog, false);

                AppLog.IsVisibleChanged+=AppLog_IsVisibleChanged;

                SyncDockingManager.BeginInit();
                SyncDockingManager.Children.Add(AppLog);
                SyncDockingManager.EndInit();
            }
        }

        private void AppLog_IsVisibleChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            if(!e.OldValue.Equals(e.NewValue))
            {
                this.MenuItemAppLog.IsEnabled = !this.MenuItemAppLog.IsEnabled;
                if (!this.MenuItemAppLog.IsEnabled) AppLog = null;
            }
        }

        private void MenuItemReceiptLog_Click(object sender, RoutedEventArgs e)
        {
            UserControl uc = new UserControl_Log();
            DockingManager.SetHeader(uc, "ReceiptLog");
            DockingManager.SetState(uc, DockState.Float);
            DockingManager.SetCanFloat(uc, true);
            DockingManager.SetCanAutoHide(uc, true);
            DockingManager.SetCanDock(uc, true);
            DockingManager.SetDockAbility(uc, DockAbility.All);

            SyncDockingManager.BeginInit();
            SyncDockingManager.Children.Add(uc);
            SyncDockingManager.EndInit();
        }

        private void MenuItemVRZ_Click(object sender, RoutedEventArgs e)
        {
            UserControl uc = new UserControl_VRZ();
            DockingManager.SetHeader(uc, "VRZ");
            DockingManager.SetState(uc, DockState.Document);
            DockingManager.SetCanFloat(uc, false);
            DockingManager.SetCanAutoHide(uc, true);
            DockingManager.SetCanDock(uc, false);
            DockingManager.SetDockAbility(uc, DockAbility.Tabbed);

            SyncDockingManager.BeginInit();
            SyncDockingManager.Children.Add(uc);
            SyncDockingManager.EndInit();
        }
    }
}